<script setup lang="ts">
const props = defineProps<{ gene: string }>();

const { fetchTriboliumGenes } = useGeneService();
const { data: triboliumGene } = await useAsyncData(
  `tribolium-gene-${props.gene}`,
  async () => (await fetchTriboliumGenes([props.gene]))[0],
);

if (!triboliumGene.value) {
  if (/^i[bB]_[\d]{5}$/.test(props.gene)) {
    await navigateTo(`/search/${props.gene}`);
  }
  throw createError({
    statusCode: 404,
    message: `Gene ${props.gene} not found`,
  });
}

const genomicLocation = computed(() => {
  if (!triboliumGene.value) return null;
  const { seqname, start, end } = triboliumGene.value;
  return `${seqname}:${start}..${end}`;
});

// const { $config } = useNuxtApp();

// const genomeBrowserLink = computed(() => {
//   if (!genomicLocation.value) return undefined;
//   return `${$config.public.uiPages.genomebrowser}/?assembly=Tcas5.2&tracks=tcas5_iBeetle.sorted.gff,ib.sorted.gff&loc=${genomicLocation.value}`;
// });

const sequences = computed(() => {
  if (!triboliumGene.value) return null;
  const { id, mRNAs, CDS, proteins } = triboliumGene.value;
  return [
    {
      text: "View mRNA sequences",
      title: `${id} mRNAs`,
      sequences: mRNAs,
    },
    {
      text: "View coding sequences",
      title: `${id} CDS`,
      sequences: CDS,
    },
    {
      text: "View protein sequences",
      title: `${id} Proteins`,
      sequences: proteins,
    },
  ];
});
</script>

<template>
  <v-row class="pa-4">
    <v-col cols="12" sm="6" xl="7">
      <v-row dense class="text-body-1">
        <v-col cols="12"> Gene identifier: {{ gene }} </v-col>
        <v-col cols="12">
          Genomic location:
          <NuxtLink
            :to="`/genomebrowser/?loc=${genomicLocation}`"
            class="text-primary text-decoration-none"
            >{{ genomicLocation }}</NuxtLink
          >
        </v-col>
      </v-row>
    </v-col>
    <v-col cols="12" sm="6" xl="5">
      <v-row dense class="text-body-1">
        <template v-if="sequences">
          <v-col v-for="sequence in sequences" :key="sequence.title" cols="12">
            <SequenceItem v-bind="sequence" />
          </v-col>
        </template>
        <v-col v-else>
          <WarningAlert :text="`Failed to fetch sequences for gene ${gene}`" />
        </v-col>
        <v-col cols="12">
          <OutLink
            :to="`https://motif.mvls.gla.ac.uk/BeetleAtlas/?search=gene&gene=${gene}&idtype=geneID`"
          >
            View gene expression at BeetleAtlas
          </OutLink>
        </v-col>
        <v-col cols="12">
          <OutLink :to="`http://www.orthodb.org/?query=${gene}`">
            View orthologs at OrthoDB
          </OutLink>
        </v-col>
      </v-row>
    </v-col>
  </v-row>
  <v-row v-if="genomicLocation">
    <v-col>
      <GenomeBrowser :location="genomicLocation" />
    </v-col>
  </v-row>
  <v-row v-else>
    <v-col>
      <WarningAlert
        :text="`Failed to fetch genomic location for gene ${gene}`"
      />
    </v-col>
  </v-row>
</template>
